// hexview.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "hexview.h"

#include "mainfrm.h"
#include "hexvidoc.h"
#include "hexvivw.h"
#include "prtframe.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHexViewApp

BEGIN_MESSAGE_MAP(CHexViewApp, CWinApp)
	//{{AFX_MSG_MAP(CHexViewApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHexViewApp construction

CHexViewApp::CHexViewApp()
{
	m_pHexViewTempl = NULL;
	m_pPrintTempl = NULL;
}

CHexViewApp::~CHexViewApp()
{
	delete m_pPrintTempl;
	// m_pHexViewTempl is deleted by MFC
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CHexViewApp object

CHexViewApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CHexViewApp initialization

BOOL CHexViewApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

	Enable3dControls();

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	// serve as the connection between documents, frame windows and views.
	// keep a pointer to the template object in our instance data

	m_pHexViewTempl = new CMultiDocTemplate(
		IDR_HEXVIETYPE,
		RUNTIME_CLASS(CHexViewDoc),
		RUNTIME_CLASS(CMDIChildWnd),          // standard MDI child frame
		RUNTIME_CLASS(CHexView));
	AddDocTemplate(m_pHexViewTempl);

	m_pPrintTempl = new CSingleDocTemplate(
		IDR_HEXVIETYPE,
		RUNTIME_CLASS(CHexViewDoc),
		RUNTIME_CLASS(CPrintFrame),
		RUNTIME_CLASS(CHexView));

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	if (m_lpCmdLine[0] != '\0')
	{
		int nIndex;

		for (nIndex = 1; nIndex < __argc; nIndex++)
			OpenDocumentFile(__argv[nIndex]);
	}

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
	return;
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CHexViewApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CHexViewApp commands
