// hexvivw.h : interface of the CHexView class
//
/////////////////////////////////////////////////////////////////////////////

class CPrintThread;

class CHexView : public CScrollView
{
protected: // create from serialization only
	CHexView();
	DECLARE_DYNCREATE(CHexView)

	CFont*	m_pPrintFont;
	CFont*	m_pFont;
	LOGFONT	m_logfont;
	int		m_nPointSize;
	BOOL	m_bPrinting;
	int		m_nPageHeight;
	int		m_nPageWidth;
	int		m_nPrintLine;

	void CalcPageCount(CDC* pDC, CPrintInfo* pInfo);
	int MeasureFontHeight(CFont* pFont, CDC* pDC);

	BOOL	m_bPrintingThread;
	CPrintThread* m_pPrintThread;
	
// Attributes
public:
	CHexViewDoc* GetDocument();

// Operations
public:

// Overrides
	void OnFilePrint();

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHexView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual void OnInitialUpdate();
	virtual void OnPrepareDC(CDC* pDC, CPrintInfo* pInfo = NULL);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CHexView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CHexView)
	afx_msg void OnViewFont();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in hexvivw.cpp
inline CHexViewDoc* CHexView::GetDocument()
   { return (CHexViewDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
